-- The Noore Tools is a ESO AddOn by Kelnoreem, based upon work by Citadel
-- This plug-in has the initial purpose of group invites, plus other items The Noore needs
--

-- define local variables as much as possible, so scope is local
local wm = GetWindowManager()
local em = GetEventManager()
local _

-- create a namespace for TNT by declaring a top-level table that will hold everything else.
if TNT == nil then TNT = {} end

-- The AddOn name
TNT.name = "TheNooreTools"
TNT.version = "2.7"

TNT.settings = {}

TNT.defaults = {
    enabled = false,
    maxGroupSize = 4,
    watchFor = "tnt00",
    caseSensitive = false,
    onlyInCyrodiil = false,
    watchInZone = false,
    watchInTells = false,
    watchInGuild1 = true,
    watchInGuild2 = true,
    watchInGuild3 = true,
    watchInGuild4 = true,
    watchInGuild5 = true,
--    panel = true,
    alpha = 50,
    x = 40,
    y = 450,
    showtitle = true,
    shown = true,
}


--
-- RefreshWindow() is a callback for EVENT_PLAYER_ACTIVATED
--
function TNT.RefreshWindow()
    if TNT.settings.enabled then
        TNT.PopulateWindow("Code Enabled: " .. TNT.settings.watchFor)
    else
        TNT.PopulateWindow("Code Disabled: " .. TNT.settings.watchFor)
    end

end






--
-- initialization stuff
--
function TNT.Initialize(event, addon)
    -- filter for just TNT addon event
	if addon ~= TNT.name then return end
	em:UnregisterForEvent("TheNooreToolsInitialize", EVENT_ADD_ON_LOADED)

	-- load our saved variables
	TNT.settings = ZO_SavedVars:New("TheNooreToolsSavedVars", 1, nil, TNT.defaults)

	-- make a label for our keybinding
	ZO_CreateStringId("SI_BINDING_NAME_THE_NOORE_TOOLS_TOGGLE", "Toggle Window")

	-- make our options menu
	TNT.MakeMenu()

	-- also, do this last, to minimize the chance of problem zone transitions
	em:RegisterForEvent("TheNooreToolsStart", EVENT_PLAYER_ACTIVATED, function(...) TNT.RefreshWindow(...) end)

    -- EVENT_CHAT_MESSAGE_CHANNEL
    em:RegisterForEvent("TheNooreToolsStart", EVENT_CHAT_MESSAGE_CHANNEL, TNT.ChatMessage)
    em:RegisterForEvent("TheNooreToolsStart", EVENT_ACTION_LAYER_POPPED, TNT.ChatMessage)
    -- Slash Commands
    SLASH_COMMANDS["/tntenable"] = TNT.enableIt
    SLASH_COMMANDS["/tntdisable"] = TNT.disableIt
    SLASH_COMMANDS["/tntinfo"] = TNT.Report
    SLASH_COMMANDS["/tntinv"] = function(name)
        --d("|cFF0000Invited " .. name)
        GroupInviteByName(name)
    end
--    SLASH_COMMANDS["/tntkick"] = function(name)
--        d("|cFF0000Kicking " .. name)
--        GroupKickByName(name)
--    end
--    It seems kick by name expects raw character name, with gender markup. If that's true, you might have
--    to look the "pretty" name up yourself
    SLASH_COMMANDS["/tntkick"] = function(name)
        local lcname = zo_strlower(zo_strtrim(name))
        for i = 1, GetGroupSize() do
            local unitTag = GetGroupUnitTagByIndex(i)
            if unitTag and not IsUnitGroupLeader(unitTag) then
                --local rawCharacterName = GetRawUnitName(unitTag)
                local characterName = GetUnitName(unitTag)
                if lcname == zo_strlower(characterName) then
                    GroupKick(unitTag)
                    break
                end
            end
        end
    end

--    SLASH_COMMANDS["/tnticon"] = TNT.Icon
--    SLASH_COMMANDS["/tnticon_hide"] = TNT.IconHide
--    SLASH_COMMANDS["/tnticon_show"] = TNT.IconShow
end


-- register to be initialized when we're ready
em:RegisterForEvent("TheNooreToolsInitialize", EVENT_ADD_ON_LOADED, function(...) TNT.Initialize(...) end)

--
-- Handle the watch for text in char window
--
function TNT.ChatMessage(messageType, channel, fromName, text)

    --if tonumber(channel) == 2 then TNT.label:SetText(messageType .. "." .. channel .. ": " .. fromName .. " - " .. text) end
    channel = tonumber(channel)

    TNT.RefreshWindow()
--    if TNT.vars.enabled then
--        TNTWindowNooreLabel:SetText("Code Enabled: " .. TNT.settings.watchFor)
--    else
--        NooreToolsWindowNooreLabel:SetText("Code Disabled: " .. TNT.settings.watchFor)
--    end

--    if TNT.settings.panel then
--        NooreToolsWindow:SetHidden(false)
--    else
--        NooreToolsWindow:SetHidden(true)
--    end

    if not TNT.settings.enabled then return end
    if channel ~= 2 and GetUnitZone("player") ~= "Cyrodiil" and TNT.settings.onlyInCyrodiil then return end
    if IsPlayerInGroup("player") and not IsUnitGroupLeader("player") then return end
    if GetGroupSize() >= TNT.settings.maxGroupSize then return end

    --[[
        0: say
        1: yell
        2: tell in
        3: group
        4: tell out ??
        12: g1
        13: g2
        14: g3
        15: g4
        16: g5
        31: zone
    ]]

    if ( not (channel == 31 or channel == 2 or (channel >= 12 and channel <= 16)) ) then return end

    if channel == 2  and not TNT.settings.watchInTells then return end
    if channel == 31 and not TNT.settings.watchInZone then return end
    if channel == 12 and not TNT.settings.watchInGuild1 then return end
    if channel == 13 and not TNT.settings.watchInGuild2 then return end
    if channel == 14 and not TNT.settings.watchInGuild3 then return end
    if channel == 15 and not TNT.settings.watchInGuild4 then return end
    if channel == 16 and not TNT.settings.watchInGuild5 then return end

    local x, y
    if TNT.settings.caseSensitive then
        x = text
        y = TNT.settings.watchFor
    else
        x = string.upper(text)
        y = string.upper(TNT.settings.watchFor)
    end

    if (x == y) then
        GroupInviteByName(fromName)
    end
end

--
-- Response to chat window slash command for a info report.  This info is written to the addon window
-- overwritting the enalbe/text , is removed once player moves.
-- The enabled/text info is display again.
--
function TNT.Report()
    TNT.PopulateWindow("\nGroupSize: " .. GetGroupSize() .. "\nGroupLeader: " .. (IsUnitGroupLeader("player") and "Yes" or "No") .. "\nGuildNum:" .. GetNumGuilds() .. "\nGuildOneName:" .. GetGuildName(GetGuildId(1)) .. "\nZone: " .. GetUnitZone("player"))
end


--
-- Chat window slash command to enable action
--
function TNT.enableIt()
    TNT.settings.enabled = true
end

--
-- Chat window slash command to disable action
--
function TNT.disableIt()
    TNT.settings.enabled = false
end

--function TNT.Icon(number)
--    TNTWindowIcon:SetHidden(false)  -- Show the Icon Display
--    TNTWindowIcon:SetTexture(GetLargeAvARankIcon(number))  -- Set the actual texture to use
--end
--function TNT.IconHide()
--    TNTWindowIcon:SetHidden(true)  -- Hide the Icon Display
--end
--function TNT.IconShow()
--    TNTWindowIcon:SetHidden(false)  -- Show the Icon Display
--end