-- sentry to make sure TNT is declared before use
if TNT == nil then TNT = {} end

--
-- Register with LibMenu and ESO
--
function TNT.MakeMenu()
	local set = TNT.settings

    -- the panel for the addons menu
	local panelData = {
		type = "panel",
		name = "The Noore Tools",
		displayName = "The Noore Tools",
		author = "Kelnoreem",
        version = "" .. TNT.version,
        slashCommand = "/thenooretools", --(optional) will register a keybind to open to this panel
        registerForRefresh = true,	--boolean (optional) (will refresh all options controls when a setting is changed and when the panel is shown)
        registerForDefaults = true,	--boolean (optional) (will set all options controls back to default values)
	}

    -- this addons entries in the addon menu
	local optionsTable = {
		[1] = {
			type = "header",
			name = "About",
            width = "full",	--or "half" (optional)
		},

        [2] = {
            type = "description",
            title = nil,	--(optional)
            text = "Author: Kelnoreem \nVersion: " .. TNT.version .. "\n"
        },

        [3] = {
            type = "submenu",
            name = "Slash Commands",
            tooltip = "Chat box slash commands",	--(optional)
            controls = {
                [1] = {
                    type = "description",
                    title = "/tntenable",	--(optional)
                    text = "To turn on NooreTools via the Chat Box"
                },

                [2] = {
                    type = "description",
                    title = "/tntdisable",
                    text = "To turn off NooreTools via the Chat Box"
                },

                [3] = {
                    type = "description",
                    title = "/tntinfo",
                    text = "Report to window info about the group."
                },

                [4] = {
                    type = "description",
                    title = "/tntinv",
                    text = "Invite a player using account name."
                },

                [5] = {
                    type = "description",
                    title = "/thenooretools",
                    text = "Opens the settings->Addon Settings->The Noore Tools window."
                },

                [6] = {
                    type = "description",
                    title = "/reloadui",
                    text = "Whenever you join or leave a guild, for changes to appear here."
                },
            },
        },

        [4] = {
            type = "submenu",
            name = "General",
            tooltip = "General options",	--(optional)
            controls = {
                [1] = {
                    type = "checkbox",
                    name = "Enabled",
                    tooltip = "Enable Group Invites",
                    getFunc = function() return TNT.settings.enabled end,
                    setFunc = function(newValue) TNT.settings.enabled = newValue end,
                    width = "half",	--or "full" (optional)
                    warning = "Will need to reload the UI.",	--(optional)
                },

                [2] = {
                    type = "slider",
                    name = "Group Size",
                    tooltip = "Maximum Group Size.",
                    min = 2,
                    max = 24,
                    step = 1,	--(optional)
                    getFunc = function() return TNT.settings.maxGroupSize end,
                    setFunc = function(newValue) TNT.settings.maxGroupSize = newValue end,
                    width = "half",	--or "full" (optional)
                    default = 4,	--(optional)
                },

                [3] = {
                    type = "editbox",
                    name = "Invite Text",
                    tooltip = "The text to look for in the chat box.",
                    getFunc = function() return TNT.settings.watchFor end,
                    setFunc = function(newValue) TNT.settings.watchFor = newValue end,
                    isMultiline = false,	--boolean
                    width = "half",	--or "full" (optional)
                    warning = "Will need to reload the UI.",	--(optional)
                    default = TNT.settings.watchFor,	--(optional)
                },

                [4] = {
                    type = "checkbox",
                    name = "Case Sensitive",
                    tooltip = "Should the invite text be case sensitive.",
                    getFunc = function() return TNT.settings.caseSensitive end,
                    setFunc = function(newValue) TNT.settings.caseSensitive = newValue end,
                    width = "half",	--or "full" (optional)
--                    warning = "Will need to reload the UI.",	--(optional)
                },

                [5] = {
                    type = "checkbox",
                    name = "Cyrodiil Only",
                    tooltip = "Should you only invite people if you are in Cyrodiil.",
                    getFunc = function() return TNT.settings.onlyInCyrodiil end,
                    setFunc = function(newValue) TNT.settings.onlyInCyrodiil = newValue end,
                    width = "half",	--or "full" (optional)
                    --                    warning = "Will need to reload the UI.",	--(optional)
                },

--                [6] = {
--                    type = "checkbox",
--                    name = "In-Game Panel",
--                    tooltip = "Lets you toggle the in-game Panel.",
--                    getFunc = function() return TNT.settings.panel end,
--                    setFunc = function(newValue) TNT.settings.panel = newValue end,
--                    width = "half",	--or "full" (optional)
--                },
            },
        },

        [5] = {
            type = "submenu",
            name = "Guilds",
            tooltip = "Channels to monitor for invite text.",	--(optional)
            controls = {
                [1] = {
                    type = "checkbox",
                    name = "Zone",
                    tooltip = "Monitor Zone.",
                    getFunc = function() return TNT.settings.watchInZone end,
                    setFunc = function(newValue) TNT.settings.watchInZone = newValue end,
                    width = "half",	--or "full" (optional)
--                    warning = "Will need to reload the UI.",	--(optional)
                },
                [2] = {
                    type = "checkbox",
                    name = "Tells",
                    tooltip = "Monitor Tells.",
                    getFunc = function() return TNT.settings.watchInTells end,
                    setFunc = function(newValue) TNT.settings.watchInTells = newValue end,
                    width = "half",	--or "full" (optional)
                },

                [3] = {
                    type = "checkbox",
                    name = GetGuildName(GetGuildId(1)),
                    tooltip = "Monitor Guild 1.",
                    getFunc = function() return TNT.settings.watchInGuild1 end,
                    setFunc = function(newValue) TNT.settings.watchInGuild1 = newValue end,
                    width = "half",	--or "full" (optional)
                },
                [4] = {
                    type = "checkbox",
                    name = GetGuildName(GetGuildId(2)),
                    tooltip = "Monitor Guild 2.",
                    getFunc = function() return TNT.settings.watchInGuild2 end,
                    setFunc = function(newValue) TNT.settings.watchInGuild2 = newValue end,
                    width = "half",	--or "full" (optional)
                },
                [5] = {
                    type = "checkbox",
                    name = GetGuildName(GetGuildId(3)),
                    tooltip = "Monitor Guild 3.",
                    getFunc = function() return TNT.settings.watchInGuild3 end,
                    setFunc = function(newValue) TNT.settings.watchInGuild3 = newValue end,
                    width = "half",	--or "full" (optional)
                },
                [6] = {
                    type = "checkbox",
                    name = GetGuildName(GetGuildId(4)),
                    tooltip = "Monitor Guild 4.",
                    getFunc = function() return TNT.settings.watchInGuild4 end,
                    setFunc = function(newValue) TNT.settings.watchInGuild4 = newValue end,
                    width = "half",	--or "full" (optional)
                },
                [7] = {
                    type = "checkbox",
                    name = GetGuildName(GetGuildId(5)),
                    tooltip = "Monitor Guild 5.",
                    getFunc = function() return TNT.settings.watchInGuild5 end,
                    setFunc = function(newValue) TNT.settings.watchInGuild5 = newValue end,
                    width = "half",	--or "full" (optional)
                },
            },
        },


        [6] = {
            type = "submenu",
            name = "In game panel",
            tooltip = "Displays monitor text and status.",	--(optional)
            controls = {
                [1] = {
                    type = "header",
                    name = "Window Settings",
                },
                [2] = {
                    type = "slider",
                    name = "Window Background Alpha",
                    tooltip = "How transparent or opaque should the window background be?",
                    min = 0,
                    max = 100,
                    step = 5,
                    getFunc = function() return set.alpha end,
                    setFunc = function(value)
                        set.alpha = value
                        TNT.window.bg:SetCenterColor(0, 0, 0, set.alpha / 100)
                        TNT.window.bg:SetEdgeColor(0, 0, 0, set.alpha / 100)
                    end,
                    default = 60,
                },
                [3] = {
                    type = "checkbox",
                    name = "Show Title",
                    tooltip = "Display the add-on title in the window?",
                    getFunc = function() return set.showtitle end,
                    setFunc = function(value)
                        set.showtitle = value
                        TNT.window.title:SetHidden(not set.showtitle)
                        if (set.showtitle) then
                            TNT.window.zone:ClearAnchors()
                            TNT.window.zone:SetAnchor(TOP, TNT.window.title, BOTTOM, 0, 5)
                        else
                            TNT.window.zone:ClearAnchors()
                            TNT.window.zone:SetAnchor(TOP, TNT.window, TOP, 0, 5)
                        end
                    end,
                },
                [4] = {
                    type = "checkbox",
                    name = "Show Window",
                    tooltip = "Display the window?",
                    getFunc = function() return set.shown end,
                    setFunc = function(value)
                        set.shown = value
                    end,
                },
            },
        },

    }

    -- load the settings->addons menu library
    local menu = LibStub("LibAddonMenu-2.0")
	menu:RegisterAddonPanel("The_Noore_Tools", panelData)
	menu:RegisterOptionControls("The_Noore_Tools", optionsTable)
end